import { arc, scaleLinear, extent } from 'd3';

export const scatterPlot = () => {
  let data;
  let width;
  let height;
  let xValue;
  let yValue;
  
  const my = (g) => {
    const xScale = scaleLinear()
      .domain(extent(data, xValue))
      .range([0, width]);

    const yScale = scaleLinear()
      .domain(extent(data, yValue))
      .range([height, 0]);

    g.selectAll('circle')
      .data(data)
      .join('circle')
      .attr('cx', (d) => xScale(xValue(d)))
      .attr('cy', (d) => yScale(yValue(d)))
      .attr('r', 10);
  };

  my.data = function (_) {
    return arguments.length ? ((data = _), my) : data;
  };
  
  my.width = function (_) {
    return arguments.length ? ((width = _), my) : width;
  };
  
  my.height = function (_) {
    return arguments.length ? ((height = _), my) : height;
  };
  my.xValue = function (_) {
    return arguments.length ? ((xValue = _), my) : xValue;
  };
  my.yValue = function (_) {
    return arguments.length ? ((yValue = _), my) : yValue;
  };

  return my;
};
